%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_Elm_Modify_Pset(Element_list, Pset_ID)

% Функция удаляет связь элементов с property set, если Pset_ID = []

global ErrCode;

global DB_ELEMENTS;
global DB_PSETS;
global AST_PSETS;

global AT_ELEMENTS;
global AT_PSETS;

Element_list = unique(Element_list);

% Проверка существования в базе элементов
for i=1:size(Element_list,1)
    if (~DB_Elm_Exist(Element_list(i)))
        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: элемент с номером %i отсутствует в базе !\n', Element_list(i));
        ErrCode = -1;
        return;
    end
end

% Проверка существования в базе property set
if (~isempty(Pset_ID))
    if (~DB_PSet_Exist(Pset_ID))
        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: property set с номером %i отсутствует в базе !\n', Pset_ID);
        ErrCode = -1;
        return;
    end
end

% Проверка на совместимость элементов с property set
if (~isempty(Pset_ID))
    
    for i=1:size(Element_list,1)

        switch DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type

            case {'Tet', 'Wedge', 'Hex'}

                switch DB_PSETS{AT_PSETS(Pset_ID)}.type
                    case 'PSOLID'
                        % Допустимый property set
                    case {'PCOMP', 'PCOMPG', 'PSHELL'}
                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: элемент с номером %i [%s] не совместим с property set с номером %i [%s] !\n', Element_list(i), DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type, Pset_ID, DB_PSETS{AT_PSETS(Pset_ID)}.type);
                        ErrCode = -1;
                        return;
                    case {'PBUSH', 'PROD', 'PBMSECT', 'PBRSECT', 'PBAR', 'PBARL', 'PBEAM', 'PBEAML', 'PBCOMP'}
                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: элемент с номером %i [%s] не совместим с property set с номером %i [%s] !\n', Element_list(i), DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type, Pset_ID, DB_PSETS{AT_PSETS(Pset_ID)}.type);
                        ErrCode = -1;
                        return;
                    otherwise
                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: обнаружен неизвестный тип property set [%s] !\n', DB_PSETS{AT_PSETS(Pset_ID)}.type);
                        fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
                        ErrCode = -1;
                        return;
                end

            case {'Quad', 'Tria'}

                switch DB_PSETS{AT_PSETS(Pset_ID)}.type
                    case 'PSOLID'
                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: элемент с номером %i [%s] не совместим с property set с номером %i [%s] !\n', Element_list(i), DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type, Pset_ID, DB_PSETS{AT_PSETS(Pset_ID)}.type);
                        ErrCode = -1;
                        return;
                    case {'PCOMP', 'PCOMPG', 'PSHELL'}
                        % Допустимый property set
                    case {'PBUSH', 'PROD', 'PBMSECT', 'PBRSECT', 'PBAR', 'PBARL', 'PBEAM', 'PBEAML', 'PBCOMP'}
                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: элемент с номером %i [%s] не совместим с property set с номером %i [%s] !\n', Element_list(i), DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type, Pset_ID, DB_PSETS{AT_PSETS(Pset_ID)}.type);
                        ErrCode = -1;
                        return;
                    otherwise
                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: обнаружен неизвестный тип property set [%s] !\n', DB_PSETS{AT_PSETS(Pset_ID)}.type);
                        fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
                        ErrCode = -1;
                        return;
                end

            case 'Bar'

                switch DB_PSETS{AT_PSETS(Pset_ID)}.type
                    case 'PSOLID'
                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: элемент с номером %i [%s] не совместим с property set с номером %i [%s] !\n', Element_list(i), DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type, Pset_ID, DB_PSETS{AT_PSETS(Pset_ID)}.type);
                        ErrCode = -1;
                        return;
                    case {'PCOMP', 'PCOMPG', 'PSHELL'}
                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: элемент с номером %i [%s] не совместим с property set с номером %i [%s] !\n', Element_list(i), DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type, Pset_ID, DB_PSETS{AT_PSETS(Pset_ID)}.type);
                        ErrCode = -1;
                        return;
                    case {'PBUSH', 'PROD', 'PBMSECT', 'PBRSECT', 'PBAR', 'PBARL', 'PBEAM', 'PBEAML', 'PBCOMP'}
                        % Допустимый property set
                    otherwise
                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: обнаружен неизвестный тип property set [%s] !\n', DB_PSETS{AT_PSETS(Pset_ID)}.type);
                        fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
                        ErrCode = -1;
                        return;
                end

            otherwise

                fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: обнаружен неизвестный тип элемента с номером %i [%s] !\n', Element_list(i), DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type);
                fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;

        end

    end
    
end

% Цикл по массиву элементов
for i=1:size(Element_list,1)

    % Пропуск элемента в случае совпадения property set
    if ((~isempty(Pset_ID)) && (~isempty(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)) && (DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID == Pset_ID))
        continue;
    end

    % Удаление номера элемента из баз, связанных со старым property set
    if (~isempty(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID))

        switch DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type

            case {'Quad', 'Tria'}

                DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Ori_Field_ID, Element_list(i));
                if (ErrCode < 0)
                    return;
                end

                DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Offset_Field_ID, Element_list(i));
                if (ErrCode < 0)
                    return;
                end

            case 'Bar'

                switch DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.type

                    case 'PBUSH'

                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Ori_CID_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end

                    case 'PROD'

                        % Ничего не делаем

                    case {'PBMSECT', 'PBRSECT', 'PBAR', 'PBARL', 'PBEAM', 'PBEAML', 'PBCOMP'}

                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Ori_vector_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end

                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Offset_vector_A_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end

                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Offset_vector_B_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end

                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Pinned_DOFs_A_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end

                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Pinned_DOFs_B_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end

                    otherwise

                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: обнаружен неизвестный тип property set балочного элемента с номером %i [%s] !\n', Element_list(i), DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.type);
                        fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
                        ErrCode = -1;
                        return;

                end

            case {'Tet', 'Wedge', 'Hex'}
                
                % Ничего не делаем

            otherwise
                fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: обнаружен неизвестный тип элемента с номером %i [%s] !\n', Element_list(i), DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type);
                fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;

        end

        AST_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Elm_list = setdiff(AST_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Elm_list, Element_list(i));
        if (isempty(AST_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Elm_list))
            AST_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Elm_list = [];
        end

    end

    % Внесение номера элемента в базы, связанные с новым property set
    if (~isempty(Pset_ID))
    
        switch DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type

            case {'Quad', 'Tria'}

                Default_Ori = DB_Field_Get_Default_Value(DB_PSETS{AT_PSETS(Pset_ID)}.Ori_Field_ID);

                DB_Field_Add_Record(DB_PSETS{AT_PSETS(Pset_ID)}.Ori_Field_ID, Element_list(i), Default_Ori);
                if (ErrCode < 0)
                    return;
                end

                Default_Offset = DB_Field_Get_Default_Value(DB_PSETS{AT_PSETS(Pset_ID)}.Offset_Field_ID);

                DB_Field_Add_Record(DB_PSETS{AT_PSETS(Pset_ID)}.Offset_Field_ID, Element_list(i), Default_Offset);
                if (ErrCode < 0)
                    return;
                end

            case 'Bar'

                switch DB_PSETS{AT_PSETS(Pset_ID)}.type

                    case 'PBUSH'

                        Default_Ori_CID = DB_Field_Get_Default_Value(DB_PSETS{AT_PSETS(Pset_ID)}.Ori_CID_Field_ID);

                        DB_Field_Add_Record(DB_PSETS{AT_PSETS(Pset_ID)}.Ori_CID_Field_ID, Element_list(i), Default_Ori_CID);
                        if (ErrCode < 0)
                            return;
                        end

                    case 'PROD'

                        % Ничего не делаем

                    case {'PBMSECT', 'PBRSECT', 'PBAR', 'PBARL', 'PBEAM', 'PBEAML', 'PBCOMP'}

                        Default_Ori_vector = DB_Field_Get_Default_Value(DB_PSETS{AT_PSETS(Pset_ID)}.Ori_vector_Field_ID);

                        DB_Field_Add_Record(DB_PSETS{AT_PSETS(Pset_ID)}.Ori_vector_Field_ID, Element_list(i), Default_Ori_vector);
                        if (ErrCode < 0)
                            return;
                        end

                        Default_Offset_vector_A = DB_Field_Get_Default_Value(DB_PSETS{AT_PSETS(Pset_ID)}.Offset_vector_A_Field_ID);

                        DB_Field_Add_Record(DB_PSETS{AT_PSETS(Pset_ID)}.Offset_vector_A_Field_ID, Element_list(i), Default_Offset_vector_A);
                        if (ErrCode < 0)
                            return;
                        end

                        Default_Offset_vector_B = DB_Field_Get_Default_Value(DB_PSETS{AT_PSETS(Pset_ID)}.Offset_vector_B_Field_ID);

                        DB_Field_Add_Record(DB_PSETS{AT_PSETS(Pset_ID)}.Offset_vector_B_Field_ID, Element_list(i), Default_Offset_vector_B);
                        if (ErrCode < 0)
                            return;
                        end

                        Default_Pinned_DOFs_A = DB_Field_Get_Default_Value(DB_PSETS{AT_PSETS(Pset_ID)}.Pinned_DOFs_A_Field_ID);

                        DB_Field_Add_Record(DB_PSETS{AT_PSETS(Pset_ID)}.Pinned_DOFs_A_Field_ID, Element_list(i), Default_Pinned_DOFs_A);
                        if (ErrCode < 0)
                            return;
                        end

                        Default_Pinned_DOFs_B = DB_Field_Get_Default_Value(DB_PSETS{AT_PSETS(Pset_ID)}.Pinned_DOFs_B_Field_ID);

                        DB_Field_Add_Record(DB_PSETS{AT_PSETS(Pset_ID)}.Pinned_DOFs_B_Field_ID, Element_list(i), Default_Pinned_DOFs_B);
                        if (ErrCode < 0)
                            return;
                        end

                    otherwise

                        fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: обнаружен неизвестный тип property set, предназначенный для балочного элемента с номером %i [%s] !\n', Element_list(i), DB_PSETS{AT_PSETS(Pset_ID)}.type);
                        fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
                        ErrCode = -1;
                        return;

                end

            case {'Tet', 'Wedge', 'Hex'}

                % Ничего не делаем

            otherwise
                fprintf (1, '\nОшибка функции DB_Elm_Modify_Pset: обнаружен неизвестный тип элемента с номером %i [%s] !\n', Element_list(i), DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type);
                fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;

        end

        AST_PSETS{AT_PSETS(Pset_ID)}.Elm_list = Union_Column(AST_PSETS{AT_PSETS(Pset_ID)}.Elm_list, Element_list(i));
    
    end

    % Внесение изменений в запись об элементе
    DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID = Pset_ID;

end
